<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLMutationMessage Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classTIGLMutationMessage-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLMutationMessage Class Reference<div class="ingroups"><a class="el" href="group__mutation__engine.html">Mutation Engine</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core mutation Massage container class.  
 <a href="classTIGLMutationMessage.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglMutationMessage_8hpp_source.html">tiglMutationMessage.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:accca8b14abee53083d4b770e4f953922"><td class="memItemLeft" align="right" valign="top">MUTATION_MESSAGE_CODE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#accca8b14abee53083d4b770e4f953922">getMessageCode</a> ()</td></tr>
<tr class="memdesc:accca8b14abee53083d4b770e4f953922"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the mutation message code  <a href="#accca8b14abee53083d4b770e4f953922">More...</a><br /></td></tr>
<tr class="separator:accca8b14abee53083d4b770e4f953922"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d17a5a5e1dfe646b1dc7e8761a351b7"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a3d17a5a5e1dfe646b1dc7e8761a351b7">getSizeInBytes</a> ()</td></tr>
<tr class="memdesc:a3d17a5a5e1dfe646b1dc7e8761a351b7"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading the overall message body  <a href="#a3d17a5a5e1dfe646b1dc7e8761a351b7">More...</a><br /></td></tr>
<tr class="separator:a3d17a5a5e1dfe646b1dc7e8761a351b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f973031daac84719897d93512d351ab"><td class="memItemLeft" align="right" valign="top">int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a3f973031daac84719897d93512d351ab">getDstDev</a> ()</td></tr>
<tr class="memdesc:a3f973031daac84719897d93512d351ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading teh destination device  <a href="#a3f973031daac84719897d93512d351ab">More...</a><br /></td></tr>
<tr class="separator:a3f973031daac84719897d93512d351ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6fb578a6baf57eeddee242c28c334536"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a6fb578a6baf57eeddee242c28c334536"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a6fb578a6baf57eeddee242c28c334536">getDstVertex</a> (ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a6fb578a6baf57eeddee242c28c334536"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns destination vertex  <a href="#a6fb578a6baf57eeddee242c28c334536">More...</a><br /></td></tr>
<tr class="separator:a6fb578a6baf57eeddee242c28c334536"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d1bbd783f0209096d743278a88555cf"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a1d1bbd783f0209096d743278a88555cf">pack</a> (uint8_t *buf)</td></tr>
<tr class="memdesc:a1d1bbd783f0209096d743278a88555cf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Packs the mutation message into bytes the packed message contains the message code and the message body.  <a href="#a1d1bbd783f0209096d743278a88555cf">More...</a><br /></td></tr>
<tr class="separator:a1d1bbd783f0209096d743278a88555cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f939c9fab8f95de9e5a7ce5e4e21764"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a9f939c9fab8f95de9e5a7ce5e4e21764">unpack</a> (uint8_t *buf)</td></tr>
<tr class="memdesc:a9f939c9fab8f95de9e5a7ce5e4e21764"><td class="mdescLeft">&#160;</td><td class="mdescRight">Unpacks a mutation message to the object fields.  <a href="#a9f939c9fab8f95de9e5a7ce5e4e21764">More...</a><br /></td></tr>
<tr class="separator:a9f939c9fab8f95de9e5a7ce5e4e21764"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afaadae81d282d01fa6890bb5ec7c51ad"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:afaadae81d282d01fa6890bb5ec7c51ad"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#afaadae81d282d01fa6890bb5ec7c51ad">readVertexMessage</a> (<a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> *vertex)</td></tr>
<tr class="memdesc:afaadae81d282d01fa6890bb5ec7c51ad"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procedure for reading add/migrate vertex messages.  <a href="#afaadae81d282d01fa6890bb5ec7c51ad">More...</a><br /></td></tr>
<tr class="separator:afaadae81d282d01fa6890bb5ec7c51ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7dcf60d501682468cf9eaf3ff3991713"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a7dcf60d501682468cf9eaf3ff3991713"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a7dcf60d501682468cf9eaf3ff3991713">readSimpleVertexMessage</a> (ID_TYPE *id)</td></tr>
<tr class="memdesc:a7dcf60d501682468cf9eaf3ff3991713"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procedure for reading add/migrate vertex messages. It.  <a href="#a7dcf60d501682468cf9eaf3ff3991713">More...</a><br /></td></tr>
<tr class="separator:a7dcf60d501682468cf9eaf3ff3991713"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa74f399c9cebff04a96b3404a51c5e1b"><td class="memTemplParams" colspan="2">template&lt;typename EDGE_TYPE , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:aa74f399c9cebff04a96b3404a51c5e1b"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#aa74f399c9cebff04a96b3404a51c5e1b">readEdgeMessage</a> (<a class="el" href="classTIGLContainersEdgeBase.html">EDGE_TYPE</a> *edge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:aa74f399c9cebff04a96b3404a51c5e1b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procedure for reading add edge messages.  <a href="#aa74f399c9cebff04a96b3404a51c5e1b">More...</a><br /></td></tr>
<tr class="separator:aa74f399c9cebff04a96b3404a51c5e1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f613f63ba43876ccfb71c8345062cfc"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a7f613f63ba43876ccfb71c8345062cfc"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a7f613f63ba43876ccfb71c8345062cfc">readSimpleEdgeMessage</a> (ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a7f613f63ba43876ccfb71c8345062cfc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procedure for reading remove edge messages. It has two outupts.  <a href="#a7f613f63ba43876ccfb71c8345062cfc">More...</a><br /></td></tr>
<tr class="separator:a7f613f63ba43876ccfb71c8345062cfc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab9271622ced744b984d48b1d7279aa9c"><td class="memTemplParams" colspan="2">template&lt;typename EdgeType , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:ab9271622ced744b984d48b1d7279aa9c"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#ab9271622ced744b984d48b1d7279aa9c">writeEdgeMessage</a> (MUTATION_MESSAGE_CODE code, EdgeType *edge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:ab9271622ced744b984d48b1d7279aa9c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procedure for writing ADD edge messages.  <a href="#ab9271622ced744b984d48b1d7279aa9c">More...</a><br /></td></tr>
<tr class="separator:ab9271622ced744b984d48b1d7279aa9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a183239c71e1e921ce501e10376baa0d5"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a183239c71e1e921ce501e10376baa0d5"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a183239c71e1e921ce501e10376baa0d5">writeSimpleEdgeMessage</a> (MUTATION_MESSAGE_CODE code, ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a183239c71e1e921ce501e10376baa0d5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procedure for writing REMOVE edge messages.  <a href="#a183239c71e1e921ce501e10376baa0d5">More...</a><br /></td></tr>
<tr class="separator:a183239c71e1e921ce501e10376baa0d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af860e1dbf7c39e451d6eaf39d2c34713"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:af860e1dbf7c39e451d6eaf39d2c34713"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#af860e1dbf7c39e451d6eaf39d2c34713">writeVertexMessage</a> (MUTATION_MESSAGE_CODE code, <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> *vertex)</td></tr>
<tr class="memdesc:af860e1dbf7c39e451d6eaf39d2c34713"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procedure for writing ADD/MIGRATE vertex messages.  <a href="#af860e1dbf7c39e451d6eaf39d2c34713">More...</a><br /></td></tr>
<tr class="separator:af860e1dbf7c39e451d6eaf39d2c34713"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59efe7d8e43b57679710b703462e809d"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a59efe7d8e43b57679710b703462e809d"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a59efe7d8e43b57679710b703462e809d">writeSimpleVertexMessage</a> (MUTATION_MESSAGE_CODE code, ID_TYPE *id)</td></tr>
<tr class="memdesc:a59efe7d8e43b57679710b703462e809d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procedure for writing add empty/remove vertex messages.  <a href="#a59efe7d8e43b57679710b703462e809d">More...</a><br /></td></tr>
<tr class="separator:a59efe7d8e43b57679710b703462e809d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a7a78a4b0b8bf099b5a38afe2f5886746"><td class="memTemplParams" colspan="2">template&lt;typename EdgeType , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a7a78a4b0b8bf099b5a38afe2f5886746"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a7a78a4b0b8bf099b5a38afe2f5886746">prepareAddEdgeMessage</a> (EdgeType *pEdge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a7a78a4b0b8bf099b5a38afe2f5886746"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prepares the ADD_OUT/IN_EDGE mutation message.  <a href="#a7a78a4b0b8bf099b5a38afe2f5886746">More...</a><br /></td></tr>
<tr class="separator:a7a78a4b0b8bf099b5a38afe2f5886746"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f04a7b6741580d694fb492ddad9e552"><td class="memTemplParams" colspan="2">template&lt;typename EdgeType , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a2f04a7b6741580d694fb492ddad9e552"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a2f04a7b6741580d694fb492ddad9e552">readAddEdgeMessage</a> (EdgeType *pEdge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a2f04a7b6741580d694fb492ddad9e552"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reads the ADD/REMOVE_EDGE mutation message.  <a href="#a2f04a7b6741580d694fb492ddad9e552">More...</a><br /></td></tr>
<tr class="separator:a2f04a7b6741580d694fb492ddad9e552"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9d443dae0e56c7f05a1932937aa0295"><td class="memTemplParams" colspan="2">template&lt;typename EDGE_TYPE , typename ID_TYPE &gt; </td></tr>
<tr class="memitem:aa9d443dae0e56c7f05a1932937aa0295"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#aa9d443dae0e56c7f05a1932937aa0295">prepareRemoveEdgeMessage</a> (<a class="el" href="classTIGLContainersEdgeBase.html">EDGE_TYPE</a> *edge, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:aa9d443dae0e56c7f05a1932937aa0295"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prepares the REMOVE_OUT/IN_EDGE mutation message.  <a href="#aa9d443dae0e56c7f05a1932937aa0295">More...</a><br /></td></tr>
<tr class="separator:aa9d443dae0e56c7f05a1932937aa0295"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8c92aba9f2e483d8422cd874e7fa8f8"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:af8c92aba9f2e483d8422cd874e7fa8f8"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#af8c92aba9f2e483d8422cd874e7fa8f8">prepareRemoveEdgeMessage</a> (ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:af8c92aba9f2e483d8422cd874e7fa8f8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prepares the REMOVE_OUT/IN_EDGE mutation message.  <a href="#af8c92aba9f2e483d8422cd874e7fa8f8">More...</a><br /></td></tr>
<tr class="separator:af8c92aba9f2e483d8422cd874e7fa8f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4b5d767c6ed05892eed00407a290e599"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:a4b5d767c6ed05892eed00407a290e599"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a4b5d767c6ed05892eed00407a290e599">readRemoveEdgeMessage</a> (ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</td></tr>
<tr class="memdesc:a4b5d767c6ed05892eed00407a290e599"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reads the ADD/REMOVE_EDGE mutation message.  <a href="#a4b5d767c6ed05892eed00407a290e599">More...</a><br /></td></tr>
<tr class="separator:a4b5d767c6ed05892eed00407a290e599"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac3e3ba4f54b0d67c6e5bc7a979c2e329"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:ac3e3ba4f54b0d67c6e5bc7a979c2e329"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#ac3e3ba4f54b0d67c6e5bc7a979c2e329">prepareEmptyVertexMessage</a> (ID_TYPE *vertexId)</td></tr>
<tr class="memdesc:ac3e3ba4f54b0d67c6e5bc7a979c2e329"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prepares the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message.  <a href="#ac3e3ba4f54b0d67c6e5bc7a979c2e329">More...</a><br /></td></tr>
<tr class="separator:ac3e3ba4f54b0d67c6e5bc7a979c2e329"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af3b1ee90ab9cad65a113cdd51cfd9522"><td class="memTemplParams" colspan="2">template&lt;typename ID_TYPE &gt; </td></tr>
<tr class="memitem:af3b1ee90ab9cad65a113cdd51cfd9522"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#af3b1ee90ab9cad65a113cdd51cfd9522">readEmptyVertexMessage</a> (ID_TYPE *vertexId)</td></tr>
<tr class="memdesc:af3b1ee90ab9cad65a113cdd51cfd9522"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reads the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message.  <a href="#af3b1ee90ab9cad65a113cdd51cfd9522">More...</a><br /></td></tr>
<tr class="separator:af3b1ee90ab9cad65a113cdd51cfd9522"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9189e2cb953e7028b7523db1be12335"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:ae9189e2cb953e7028b7523db1be12335"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#ae9189e2cb953e7028b7523db1be12335">prepareAddVertexMessage</a> (<a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> *vertex)</td></tr>
<tr class="memdesc:ae9189e2cb953e7028b7523db1be12335"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prepares the ADD_VERTEX message.  <a href="#ae9189e2cb953e7028b7523db1be12335">More...</a><br /></td></tr>
<tr class="separator:ae9189e2cb953e7028b7523db1be12335"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9985aad84627e17146f6413e8d117766"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:a9985aad84627e17146f6413e8d117766"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a9985aad84627e17146f6413e8d117766">readAddVertexMessage</a> (<a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> *pVertex)</td></tr>
<tr class="memdesc:a9985aad84627e17146f6413e8d117766"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reads the ADD_VERTEX.  <a href="#a9985aad84627e17146f6413e8d117766">More...</a><br /></td></tr>
<tr class="separator:a9985aad84627e17146f6413e8d117766"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:abdba38d3553d9c36b310093f96aaf4b8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abdba38d3553d9c36b310093f96aaf4b8"></a>
MUTATION_MESSAGE_CODE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#abdba38d3553d9c36b310093f96aaf4b8">messageCode</a></td></tr>
<tr class="memdesc:abdba38d3553d9c36b310093f96aaf4b8"><td class="mdescLeft">&#160;</td><td class="mdescRight">code of the mutation message <br /></td></tr>
<tr class="separator:abdba38d3553d9c36b310093f96aaf4b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a8f8c15be0b5ba3e8d697091ed3c584"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4a8f8c15be0b5ba3e8d697091ed3c584"></a>
vector&lt; uint8_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a4a8f8c15be0b5ba3e8d697091ed3c584">messageBody</a></td></tr>
<tr class="memdesc:a4a8f8c15be0b5ba3e8d697091ed3c584"><td class="mdescLeft">&#160;</td><td class="mdescRight">message body in bytes <br /></td></tr>
<tr class="separator:a4a8f8c15be0b5ba3e8d697091ed3c584"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4849bc62b4860dcab8fdddbc076a4241"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4849bc62b4860dcab8fdddbc076a4241"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLMutationMessage.html#a4849bc62b4860dcab8fdddbc076a4241">otherDevice</a></td></tr>
<tr class="memdesc:a4849bc62b4860dcab8fdddbc076a4241"><td class="mdescLeft">&#160;</td><td class="mdescRight">the destination device <br /></td></tr>
<tr class="separator:a4849bc62b4860dcab8fdddbc076a4241"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Core mutation Massage container class. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a3f973031daac84719897d93512d351ab"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int_fast32_t TIGLMutationMessage::getDstDev </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading teh destination device </p>
<p>/ </p>

</div>
</div>
<a class="anchor" id="a6fb578a6baf57eeddee242c28c334536"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::getDstVertex </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>returns destination vertex </p>
<p>/ </p>

</div>
</div>
<a class="anchor" id="accca8b14abee53083d4b770e4f953922"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">MUTATION_MESSAGE_CODE TIGLMutationMessage::getMessageCode </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>returns the mutation message code </p>
<p>/ </p>

</div>
</div>
<a class="anchor" id="a3d17a5a5e1dfe646b1dc7e8761a351b7"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::getSizeInBytes </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading the overall message body </p>
<p>/ </p>

</div>
</div>
<a class="anchor" id="a1d1bbd783f0209096d743278a88555cf"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::pack </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Packs the mutation message into bytes the packed message contains the message code and the message body. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>output buffer for packed message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="a7a78a4b0b8bf099b5a38afe2f5886746"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EdgeType , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareAddEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">EdgeType *&#160;</td>
          <td class="paramname"><em>pEdge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prepares the ADD_OUT/IN_EDGE mutation message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pEdge</td><td>pointer to the edge to be added </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the ID of the target vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="ae9189e2cb953e7028b7523db1be12335"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareAddVertexMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> *&#160;</td>
          <td class="paramname"><em>vertex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prepares the ADD_VERTEX message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertex</td><td>pointer to the vertex object </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the size of the message body </dd></dl>

</div>
</div>
<a class="anchor" id="ac3e3ba4f54b0d67c6e5bc7a979c2e329"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareEmptyVertexMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>vertexId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prepares the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexId</td><td>vertex ID </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="aa9d443dae0e56c7f05a1932937aa0295"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EDGE_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareRemoveEdgeMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classTIGLContainersEdgeBase.html">EDGE_TYPE</a> *&#160;</td>
          <td class="paramname"><em>edge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prepares the REMOVE_OUT/IN_EDGE mutation message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">edge</td><td>pointer to the the edge object </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the target vertex where we remove this edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="af8c92aba9f2e483d8422cd874e7fa8f8"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::prepareRemoveEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>nbrVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prepares the REMOVE_OUT/IN_EDGE mutation message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">nbrVertex</td><td>pointer to the other side of the vertex </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the target vertex where we remove this edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="a2f04a7b6741580d694fb492ddad9e552"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EdgeType , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readAddEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">EdgeType *&#160;</td>
          <td class="paramname"><em>pEdge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reads the ADD/REMOVE_EDGE mutation message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pEdge</td><td>pointer to the read buffer of the edge </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the ID of targe tvertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, otherwise false </dd></dl>

</div>
</div>
<a class="anchor" id="a9985aad84627e17146f6413e8d117766"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readAddVertexMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> *&#160;</td>
          <td class="paramname"><em>pVertex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reads the ADD_VERTEX. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pVertex</td><td>pointer to the empty vertex object that's filled inside the function </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa74f399c9cebff04a96b3404a51c5e1b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EDGE_TYPE , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readEdgeMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classTIGLContainersEdgeBase.html">EDGE_TYPE</a> *&#160;</td>
          <td class="paramname"><em>edge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Procedure for reading add edge messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">edge</td><td>pointer to the edge object, </td></tr>
    <tr><td class="paramname">targetVertex</td><td>and the target vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="af3b1ee90ab9cad65a113cdd51cfd9522"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readEmptyVertexMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>vertexId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reads the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexId</td><td>output vertex ID </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, otherwise false </dd></dl>

</div>
</div>
<a class="anchor" id="a4b5d767c6ed05892eed00407a290e599"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readRemoveEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>nbrVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reads the ADD/REMOVE_EDGE mutation message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">nbrVertex</td><td>pointer to the other side of the vertex </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the target vertex where we remove this edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, otherwise false </dd></dl>

</div>
</div>
<a class="anchor" id="a7f613f63ba43876ccfb71c8345062cfc"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readSimpleEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>nbrVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Procedure for reading remove edge messages. It has two outupts. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">nbrVertex</td><td>pointer to other side of the edge, </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the vertex ID of the vertex from which the edge is removed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a7dcf60d501682468cf9eaf3ff3991713"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readSimpleVertexMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Procedure for reading add/migrate vertex messages. It. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>pointer the vertex ID </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afaadae81d282d01fa6890bb5ec7c51ad"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::readVertexMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> *&#160;</td>
          <td class="paramname"><em>vertex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Procedure for reading add/migrate vertex messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertex</td><td>pointer to the vertex object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9f939c9fab8f95de9e5a7ce5e4e21764"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t TIGLMutationMessage::unpack </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Unpacks a mutation message to the object fields. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>input buffer for the packed message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the size (in bytes) of the unpacked message </dd></dl>

</div>
</div>
<a class="anchor" id="ab9271622ced744b984d48b1d7279aa9c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename EdgeType , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::writeEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">MUTATION_MESSAGE_CODE&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">EdgeType *&#160;</td>
          <td class="paramname"><em>edge</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Procedure for writing ADD edge messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">code</td><td>message code: can be either ADD_OUT_EDGE or ADD_IN_EDGE </td></tr>
    <tr><td class="paramname">edge</td><td>pointer to the edge object </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the vertex ID of the vertex to which the edge is added </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a183239c71e1e921ce501e10376baa0d5"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::writeSimpleEdgeMessage </td>
          <td>(</td>
          <td class="paramtype">MUTATION_MESSAGE_CODE&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>nbrVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>targetVertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Procedure for writing REMOVE edge messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">code</td><td>message code: can be either REMOVE_OUT_EDGE or REMOVE_IN_EDGE </td></tr>
    <tr><td class="paramname">nbrVertex</td><td>pointer to the vertex ID of the other side of the edge </td></tr>
    <tr><td class="paramname">targetVertex</td><td>pointer to the vertex ID of the vertex to which the edge is added </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a59efe7d8e43b57679710b703462e809d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::writeSimpleVertexMessage </td>
          <td>(</td>
          <td class="paramtype">MUTATION_MESSAGE_CODE&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE *&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Procedure for writing add empty/remove vertex messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">code</td><td>message code: can be either ADD_EMPTY_VERTEX or REMOVE_VERTEX </td></tr>
    <tr><td class="paramname">id</td><td>pointer to the vertex id </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af860e1dbf7c39e451d6eaf39d2c34713"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLMutationMessage::writeVertexMessage </td>
          <td>(</td>
          <td class="paramtype">MUTATION_MESSAGE_CODE&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> *&#160;</td>
          <td class="paramname"><em>vertex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Procedure for writing ADD/MIGRATE vertex messages. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">code</td><td>message code: can be either ADD_VERTEX or MIGRATE_VERTEX </td></tr>
    <tr><td class="paramname">vertex</td><td>pointer to the vertex object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tiglMutationMessage_8hpp_source.html">tiglMutationMessage.hpp</a></li>
<li><a class="el" href="tiglMutationMessageImplementation_8hpp_source.html">tiglMutationMessageImplementation.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:59 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
